import java.util.*;
import java.io.*;


public class Context {

    protected HashMap localIds;
    protected PrintStream w;
    
    public Context() {
	localIds = new HashMap(2048);
	w = new PrintStream(new BufferedOutputStream(System.out));
    }

    public Expr newConst(String name) {
	Position p = new Position(0,0,"predeclared");
	Expr e = new Expr(p, Expr.CONST, name);
	pushId(name, e);
	return e;
    }

    // map varname to v.
    public void pushId(String varname, Expr v) {
	Stack s = (Stack)localIds.get(varname);
	if (s == null) {
	    s = new Stack();
	    localIds.put(varname, s);
	}
	s.push(v);
    }

    public void popId(String varname) {
	((Stack)localIds.get(varname)).pop();
    }

    // try to find an identifier with the given name
    public Expr lookup(String name) {
	Stack s = (Stack)localIds.get(name);
	if (s != null && !s.empty())
	    return (Expr)s.peek();

	return null; // can't find this identifier
    }

}
